#!/bin/tcsh -f

alias awk 'gawk'
alias sed 'gsed'

set min_cc = 9500
#set min_cc = 9000

set min_coh = 9500
#set min_coh = 9000

#set tw = 2.56
#set tw = 5.12
set tw = 40.00

#set seq_prefix = "HF"
set seq_prefix = "MEX"


#foreach station (BRIB)
#foreach station (SMCB)
#foreach station (CMSB)

#foreach station (ARIG CAIG MEIG MMIG OXIG PNIG PLIG TLIG ZIIG)
foreach station  (ARIG CAIG MEIG MMIG OXIG PEIG PLIG PNIG TLIG YOIG ZIIG )
#foreach station (ARIG)
#foreach station (ALL)
#foreach station (FAST)
#foreach station (CGP1)

#foreach station ( BRIB SMCB CMSB CGP1)
#foreach station (BRIB CMSB SMCB CGP1 CMW1 CMH CAL CNI CSP CMC CMH CSH CSL BKS CCY CDV CVL CLC)
#foreach station (CLC)
#foreach station (CAL)
#foreach station (BRIB CGP1 CMSB SMCB CMW1 CNI CAL)

# no erro Dec 20 2010 fo BRIB CAL CGP1 CMC CMH CMJ CMSB CMW1 CNI CSL NSP SMCB
#foreach station (BRIB CAL CGP1 CMC CMH CMJ CMSB CMW1 CNI CSL NSP SMCB)
#foreach station (BRIB)
#foreach station (CAL)
# 

set com = "BHZ"
if($station == "BKS" ) then
set com = HHZ
endif

if($station == "BRIB" ) then
set com = DP1
endif

if($station == "CMSB" ) then
set com = DP1
endif
if($station == "SMCB" ) then
set com = DP1
endif

if($station == "CGP1" ) then
set com = HN1
endif

if($station == "CMW1" ) then
set com = HN1
endif
if($station == "CNI" ) then
set com = EHZ
endif
if($station == "CAL" ) then
set com = EHZ
endif
if($station == "NSP" ) then
set com = EHZ
endif
if($station == "CCY" ) then
set com = EHZ
endif
if($station == "CDV" ) then
set com = EHZ
endif
if($station == "CVL" ) then
set com = EHZ
endif
if($station == "CLC" ) then
set com = EHZ
endif



#foreach xc_fi ("cs_xc.out.toJul2012/"$station"."$com".allCSs."$tw".xc.8-24Hz.10.max_dist.log.tt.catalog")
#foreach xc_fi ("cs_xc.out/"$station"."$com"..allCSs."$tw".xc.8-24Hz.10.max_dist.log.tt.catalog")
foreach xc_fi ("cs_xc.out/"$station"."$com"..allCSs."$tw".xc.1-8Hz.9999999.max_dist.log.ld.catalog")

echo "# xc_fi = "$xc_fi
set output = $xc_fi".cc-coh.out"

#cat $xc_fi | awk -v min_cc=$min_cc -v min_coh=$min_coh '{if( ($3>=min_cc && $4>=min_coh) && ($1 != $2) && ($3!=10000) ){ print $0}}' >! select.dat
# evid has 0 in MEX
cat $xc_fi | awk -v min_cc=$min_cc -v min_coh=$min_coh '{if( ($3>=min_cc && $4>=min_coh) && ($1 != $2) && ($3!=10000) ){ print $5+0,$6+0,$3,$4,$5+0,$6+0}}' >! select.dat

echo "# remove 9999 9999 pair: from Luis's comment 09-28-18"
cat select.dat | awk '{if($3==9999 && $4=9999){}else{print $0}}' >! select2.dat
mv -f select2.dat select.dat
#exit

# remove burst
#cat $xc_fi | awk -v min_cc=$min_cc -v min_coh=$min_coh '{ yy1=substr($1,1,4); yy2=substr($2,1,4); subyy=(yy1-yy2); if(subyy<0){subyy=subyy*-1;} if( (subyy>=2 && $3>=min_cc && $4>=min_coh) && ($1 != $2) && ($3!=10000) ){ print $0}}' >! select.dat

#exit
RemoveDuplicat.pl select.dat >! $output
#exit
java FindSequencesRev_test $output $seq_prefix | awk '{if($1!="#") print $0}'>! $station".cluster.out"
#set ev_id = `echo $fi | awk 'BEGIN{FS="/"}{print $2}' | awk 'BEGIN{FS=".";}{print $6"."$7"."$8;}'   `

#echo "# ev_id = "$ev_id

#exit

end # xc_fi

end # station

