import java.io.*;

class FindSequencesRev_test{

    static File_Read_st file_Read_st = new File_Read_st();

    static final int event_max=1000000;
    static final int seqevent_max=5000; // how many sequences
    static final int subevent_max=1000; // how many events in sequence
    static int work_num;
    static int icc_work[],icoh_work[],work_flag[],work_flag2[];
    static int work_flag_m[],work_flag_o[],work_flag2_m[],work_flag2_o[];
    static String master_ev_work[],others_ev_work[];
    static String master_ev_ncss_work[],others_ev_ncss_work[];

    static String seqevent_id[],subevent_id[][];
    static String cc_member[][][]; // seq_id,sub_id,(0-master or 1-others)
    static String cc_member_ncss[][][]; // seq_id,sub_id,(0-master or 1-others)
    static int subevent_num[],subevent_icc[][],subevent_icoh[][];

    static int seqevent_num;
    static String seq_prefix;
    

    static public void main(String args[]){
	String master_list;
	String master_ev[],others_ev[];
	String master_ev_ncss[],others_ev_ncss[];

	String tmp_string;

	int master_num;
	int tmp_int,i0,i1,i2,i3,i4,i5;
	int icc[],icoh[];


	
	master_list=args[0];
	seq_prefix=args[1];
        file_Read_st.get_File_Read_st(master_list,event_max);
        master_num=file_Read_st.ic;
	master_ev=new String[master_num];
	others_ev=new String[master_num];

	master_ev_ncss=new String[master_num];
	others_ev_ncss=new String[master_num];
	
	icc=new int[master_num];
	icoh=new int[master_num];

	seqevent_id=new String[seqevent_max];
	subevent_num=new int[seqevent_max];

	subevent_id=new String[seqevent_max][subevent_max];
	subevent_icc=new int[seqevent_max][subevent_max];
	subevent_icoh=new int[seqevent_max][subevent_max];

	cc_member=new String[seqevent_max][subevent_max][2]; // 0-master 1-others
	cc_member_ncss=new String[seqevent_max][subevent_max][2]; // 0-master 1-others

	 for(int s=0;s<seqevent_max;s++){
	     seqevent_id[s]="";
	     subevent_num[s]=-1;
	     for(int ss=0;ss<subevent_max;ss++){
		 subevent_id[s][ss]="";
		 cc_member[s][ss][0]="";
		 cc_member[s][ss][1]="";
		 cc_member_ncss[s][ss][0]="";
		 cc_member_ncss[s][ss][1]="";

	     }
	 }
	 
	 String ncss_id[];
	 int ncss_idflag[];
	 int ncss_idnum;
	 ncss_idnum=0;
	 ncss_id=new String[event_max];
	 ncss_idflag=new int[event_max];
	 for(int s=0;s<master_num;s++){
	     tmp_string=file_Read_st.sdata[s];
	     i0=i1=i2=i3=i4=i5=0;
	     i0=tmp_string.lastIndexOf("/");
	     i1=tmp_string.indexOf(" ",i0+1);
	     i2=tmp_string.indexOf(" ",i1+1);
	     i3=tmp_string.indexOf(" ",i2+1);

	     if( (i2+1) == i3){
		 i3=tmp_string.indexOf(" ",i2+2);
	     }

	     i4=tmp_string.indexOf(" ",i3+1);
	     i5=tmp_string.indexOf(" ",i4+1);

	     //System.out.println(i0+" "+i1+" "+i2+" "+i3);
	     //1995.211.024242 1997.214.164614  6644 6384
	     master_ev[s]=tmp_string.substring(i0+1,i1);
	     others_ev[s]=tmp_string.substring(i1+1,i2);	     
	     icc[s]=Integer.parseInt(tmp_string.substring(i2+1,i3).trim());
	     
	     //icoh[s]=Integer.parseInt(tmp_string.substring(i3+1,tmp_string.length()).trim());
	     icoh[s]=Integer.parseInt(tmp_string.substring(i3+1,i4).trim());


	     master_ev_ncss[s]=tmp_string.substring(i4+1,i5);;
	     others_ev_ncss[s]=tmp_string.substring(i5+1,tmp_string.length());;
	     //System.out.println("# master_ev = "+master_ev[s]+" others_ev = "+others_ev[s]+" cc = "+icc[s]+" coh = "+icoh[s]);
	     ncss_id[ncss_idnum]=master_ev_ncss[s];
	     ncss_idflag[ncss_idnum]=0;

	     ncss_idnum++;
	     
	     
	     ncss_id[ncss_idnum]=others_ev_ncss[s];
	     ncss_idflag[ncss_idnum]=0;

	     ncss_idnum++;

	 }


	 // make work data
	 System.out.println("# master_num = "+master_num);
	
	 work_num=master_num;

	 master_ev_work=new String[work_num];
	 others_ev_work=new String[work_num];
	 icc_work=new int[work_num];
	 icoh_work=new int[work_num];
	 work_flag=new int[work_num];
	 work_flag2=new int[work_num];

	 work_flag_m=new int[work_num];
	 work_flag_o=new int[work_num];

	 work_flag2_m=new int[work_num];
	 work_flag2_o=new int[work_num];

	 master_ev_ncss_work=new String[work_num];
	 others_ev_ncss_work=new String[work_num];

	 for(int s=0;s<work_num;s++){
	     master_ev_work[s]=master_ev[s];
	     others_ev_work[s]=others_ev[s];
	     icc_work[s]=icc[s];
	     icoh_work[s]=icoh[s];
	     master_ev_ncss_work[s]=master_ev_ncss[s];
	     others_ev_ncss_work[s]=others_ev_ncss[s];

	     work_flag_m[s]=0; 
	     work_flag_o[s]=0; 
	     work_flag2_m[s]=0; 
	     work_flag2_o[s]=0; 

	     work_flag[s]=0; // not used
	     work_flag2[s]=0; // not used
	 }





	 show_workdata();
	 //System.exit(1);



	 int seq_numOUT;
	 seq_numOUT=-1;
		 
	 int flag,flag_index;
	 String ncss_uniq[];
	 int uniq_flag[];
	 ncss_uniq=new String[ncss_idnum];
	 uniq_flag=new int[ncss_idnum];

	 int uniq_num;
	 uniq_num=1;
	 ncss_uniq[0]=ncss_id[0];
	 for(int s=0;s<ncss_idnum;s++){
	     flag=1;
	     flag_index=-1;
	     System.out.println("# s = "+s+" ncss_id = "+ncss_id[s]);
	     for(int ss=0;ss<uniq_num;ss++){
		 System.out.println("# ss = "+ss+" ncss_uniq = "+ncss_uniq[ss]);
		 if(ncss_id[s].equals(ncss_uniq[ss])){
		     //break; // we have this
		     flag=0;
		     flag_index=ss;
		 }

	     }

	     if(flag==1){
		 ncss_uniq[uniq_num]=ncss_id[s];
		 uniq_flag[uniq_num]=0;
		 uniq_num++;
	     }
		 
	     
	 
	     System.out.println("# uniq_num = "+uniq_num);
	     
	 }




	 

	 

	 for(int s=0;s<uniq_num;s++){
	     String sub_idtmp[];
	     int idtmp;
	     sub_idtmp=new String[ncss_idnum];
	     idtmp=0;	   
	     System.out.println("# s = "+s+" ncss_uniq = "+ncss_uniq[s]);

	     // uniq_flag == 1 was identified already
	     System.out.println("# s = "+s+" ncss_uniq = "+ncss_uniq[s]+" uniq_flag = "+uniq_flag[s]);

	     
	     if(uniq_flag[s]==0){
		 
		 
		 for(int ss=0;ss<master_num;ss++){
		     
		     
		     // work_flag == 1 was identified already
		     //if(work_flag[ss]==0){
		     if(work_flag_m[ss]==0 && work_flag_o[ss]==0){
			 //master_ev_ncss_work[s]=master_ev_ncss[s];
			 //others_ev_ncss_work[s]=others_ev_ncss[s];
			 
			 //master
			 if(master_ev_ncss[ss].equals(ncss_uniq[s])){
			     
			     work_flag[ss]=1;
			     //flag_index=ss;
			     work_flag_m[ss]=1;
			     
			 }
			 //others
			 if(others_ev_ncss[ss].equals(ncss_uniq[s])){
			     
			     work_flag[ss]=1;
			     //flag_index=ss;
			     work_flag_o[ss]=1;
			 }



			 //if(work_flag[ss]==1){
			 if(work_flag_m[ss]==1 || work_flag_o[ss]==1){
			     System.out.println("# Identified ss = "+ss+" master_ev_work = "+master_ev_work[ss]+" others_ev_work = "+others_ev_work[ss]+" cc_work = "+icc_work[ss]+" coh_work = "+icoh_work[ss]+" "+master_ev_ncss_work[ss]+" "+others_ev_ncss_work[ss]);
			     

			     
			     sub_idtmp[idtmp]=master_ev_ncss[ss];
			     idtmp++;
				 
   			     sub_idtmp[idtmp]=others_ev_ncss[ss];
			     idtmp++;
				 

			     
			 }


		     }// if(work_flag[ss]==0){
		     


		 }// master_num // get associated
		 for(int s5=0;s5<idtmp;s5++){
		     System.out.println("# WE HAVE NOW sub_idtmp = "+sub_idtmp[s5]);
		 }










		 System.out.println("# sub_idtmp[s3] is others and master is never caught");
		 //sub_idtmp[s3] is others and master is never caught
		 int idtmp_app=0;
		 int sub_add_flag=1;

		 System.out.println("# idtmp = "+idtmp+" master_num = "+master_num);




		 for(int s4=0;s4<master_num;s4++){

		 //for(int s4=4;s4<master_num;s4++){

		     System.out.println("# Matching s4 = "+s4+" others_ev_ncss = "+others_ev_ncss[s4]);
		     System.out.println("#      Checking s4 = "+s4+" master_ev_ncss = "+master_ev_ncss[s4]);
		     System.out.println("#      current idtmp = "+idtmp);
	 
		     for(int s5=0;s5<idtmp;s5++){
			 System.out.println("# WE HAVE NOW sub_idtmp = "+sub_idtmp[s5]);
		     }
		     for(int s3=0;s3<idtmp;s3++){
			 sub_add_flag=1;
		


			 System.out.println("# Matching s4 = "+s4+" others_ev_ncss = "+others_ev_ncss[s4]+" if matches s3 = "+s3+" sub_idtmp[s3] = "+sub_idtmp[s3]);
		
			 if(sub_idtmp[s3].equals(others_ev_ncss[s4])){
			     System.out.println("# s3 = "+s3+" sub_idtmp = "+sub_idtmp[s3]+" equales to "+s4+" others_ev_ncss[s4] = "+others_ev_ncss[s4]);

			     
			     sub_add_flag=1;
			     for(int s5=0;s5<idtmp;s5++){
				 System.out.println("# then looking if master matches sub_idtmp s4 = "+s4+" master_ev_ncss = "+master_ev_ncss[s4]);
				 
				 if(sub_idtmp[s5].equals(master_ev_ncss[s4])){
				     sub_add_flag=0;
				     System.out.println("# s5 = "+s5+" sub_idtmp = "+sub_idtmp[s5]+" equales to "+s4+" master_ev_ncss[s4] = "+master_ev_ncss[s4]);
				     System.out.println("# do not add");
				     
				 }// if
				 
			     }//s5






			     
			     if(sub_add_flag==1){
				 
				 System.out.println("# add one more");
				 //sub_idtmp[idtmp+idtmp_app]=master_ev_ncss[s4];
				 //idtmp_app++;
			
				 sub_idtmp[idtmp]=master_ev_ncss[s4];
				 idtmp++;
				 //sub_idtmp[idtmp]=others_ev_ncss[ss];
			     } // sub_add_flag


			     /*
			     if(sub_add_flag==1){
				 System.out.println("# idtmp = "+idtmp+" idtmp_app = "+idtmp_app);
				 int tmp_id = idtmp+idtmp_app;
				 idtmp=tmp_id;

			     }
			     */

			 } // if(sub_idtmp[s3]==others_ev_ncss[s4]){
			
		     }//  for(int s3=0;s3<idtmp;s3++){


		 } // for(int s4=0;s4<master_num;s4++){


		 

		 for(int s5=0;s5<idtmp;s5++){
		     System.out.println("# WE HAVE NOW sub_idtmp s5 = "+s5+" sub_idtmp "+sub_idtmp[s5]);
		 }


		 // System.exit(1);






		 for(int s4=0;s4<master_num;s4++){

		 //for(int s4=4;s4<master_num;s4++){

		     System.out.println("# Matching s4 = "+s4+" master_ev_ncss = "+master_ev_ncss[s4]);
		     System.out.println("#      Checking s4 = "+s4+" others_ev_ncss = "+others_ev_ncss[s4]);
		     System.out.println("#      current idtmp = "+idtmp);
	 
		     for(int s5=0;s5<idtmp;s5++){
			 System.out.println("# WE HAVE NOW sub_idtmp = "+sub_idtmp[s5]);
		     }
		     for(int s3=0;s3<idtmp;s3++){
			 sub_add_flag=1;
		


			 System.out.println("# Matching s4 = "+s4+" master_ev_ncss = "+master_ev_ncss[s4]+" if matches s3 = "+s3+" sub_idtmp[s3] = "+sub_idtmp[s3]);
		
			 if(sub_idtmp[s3].equals(master_ev_ncss[s4])){
			     System.out.println("# s3 = "+s3+" sub_idtmp = "+sub_idtmp[s3]+" equales to "+s4+" master_ev_ncss[s4] = "+master_ev_ncss[s4]);

			     
			     sub_add_flag=1;
			     for(int s5=0;s5<idtmp;s5++){
				 System.out.println("# then looking if master matches sub_idtmp s4 = "+s4+" others_ev_ncss = "+others_ev_ncss[s4]);
				 
				 if(sub_idtmp[s5].equals(others_ev_ncss[s4])){
				     sub_add_flag=0;
				     System.out.println("# s5 = "+s5+" sub_idtmp = "+sub_idtmp[s5]+" equales to "+s4+" others_ev_ncss[s4] = "+others_ev_ncss[s4]);
				     System.out.println("# do not add");
				     
				 }// if
				 
			     }//s5






			     
			     if(sub_add_flag==1){
				 
				 System.out.println("# add one more");
				 //sub_idtmp[idtmp+idtmp_app]=others_ev_ncss[s4];
				 //idtmp_app++;
				
				 sub_idtmp[idtmp]=others_ev_ncss[s4];
				 idtmp++;
				  //sub_idtmp[idtmp]=others_ev_ncss[ss];
			     } // sub_add_flag


			     /*
			     if(sub_add_flag==1){
				 System.out.println("# idtmp = "+idtmp+" idtmp_app = "+idtmp_app);
				 int tmp_id = idtmp+idtmp_app;
				 idtmp=tmp_id;

			     }
			     */

			 } // if(sub_idtmp[s3]==master_ev_ncss[s4]){
			
		     }//  for(int s3=0;s3<idtmp;s3++){


		 } // for(int s4=0;s4<master_num;s4++){


		 





		 //idtmp=idtmp+idtmp_app;




		 // finding uniq ids uder the master uniq_id
		 //int flag,flag_index;
		 String sub_uniq[];
		 int sub_flag[];
		 sub_uniq=new String[ncss_idnum];
		 sub_flag=new int[ncss_idnum];
		 sub_uniq=new String[idtmp];
		 sub_flag=new int[idtmp];
		 
		 int sub_num;
		 sub_num=1;
		 sub_uniq[0]=sub_idtmp[0];
		 for(int s3=0;s3<idtmp;s3++){
		     flag=1;
		     flag_index=-1;
		     System.out.println("# s3 = "+s3+" sub_idtmp = "+sub_idtmp[s3]);

		     for(int s4=0;s4<sub_num;s4++){
			 System.out.println("# s4 = "+s4+" sub_uniq = "+sub_uniq[s4]);

			 
			 if(sub_idtmp[s3].equals(sub_uniq[s4])){
			     //break; // we have this
			     flag=0;
			     flag_index=s4;
			 }
			 
			 
		     }
		     
		     if(flag==1){
			 sub_uniq[sub_num]=sub_idtmp[s3];
			 sub_flag[sub_num]=0;
			 sub_num++;
		     }
		     
		     
		     
		     //System.out.println("# sub_num (uniq ids under this master id= "+sub_num);
		     
		 }
		 
		 
		 System.out.println("# sub_num (uniq ids under this master id ) = "+sub_num);



















	
		 if(sub_num > 1 ) {
		     seq_numOUT++;
		     System.out.println("SEQID "+sub_uniq[0]+" SUBNUM X "+seq_prefix+""+seq_numOUT);
					
		  

		 }

		 int seqevent_numOUT;
		 seqevent_numOUT=0;
		     
		 
		 // looking all sub_flag[s5] colldected
		 for(int s5=0;s5<sub_num;s5++){
		     String sub_idtmp2[];
		     int idtmp2;
		     sub_idtmp2=new String[ncss_idnum];
		     idtmp2=0;	   
		     System.out.println("# s5 = "+s5+" sub_uniq = "+sub_uniq[s5]+" sub_flag = "+sub_flag[s5]);
		    
		     // uniq_flag == 1 was identified already
		     
		     if(sub_flag[s5]==0){
			 
			 
			 for(int s6=0;s6<master_num;s6++){
			     
			     
			     // work_flag == 1 was identified already
			     //if(work_flag2[s6]==0){
			     if(work_flag2_m[s6]==0 && work_flag2_o[s6]==0){
				 //master_ev_ncss_work[s]=master_ev_ncss[s];
				 //others_ev_ncss_work[s]=others_ev_ncss[s];
				 
				 //master
				 if(master_ev_ncss[s6].equals(sub_uniq[s5])){
				     
				     work_flag2[s6]=1;
				     //flag_index=ss;
				     work_flag[s6]=1;

				     work_flag_m[s6]=1;
				     work_flag2_m[s6]=1;
					
				     
				 }
				 //others
				 if(others_ev_ncss[s6].equals(sub_uniq[s5])){
				     
				     work_flag2[s6]=1;
				     //flag_index=ss;
				     work_flag[s6]=1;


				     work_flag_o[s6]=1;
				     work_flag2_o[s6]=1;
				 }
				 
				 
				 
				 // if(work_flag2[s6]==1){
				 if(work_flag2_m[s6]==1 || work_flag2_o[s6]==1){
				     //System.out.println("# Identified s6 = "+s6+" master_ev_work = "+master_ev_work[s6]+" others_ev_work = "+others_ev_work[s6]+" cc_work = "+icc_work[s6]+" coh_work = "+icoh_work[s6]+" "+master_ev_ncss_work[s6]+" "+others_ev_ncss_work[s6]);
				     //System.out.println(seqevent_numOUT+" "+master_ev[s6]+" "+others_ev[s6]+" "+icc_work[s6]+" "+icoh_work[s6]+" "+master_ev_ncss_work[s6]+" "+others_ev_ncss_work[s6]+" "+seq_prefix+""+seq_numOUT);
				     
				     System.out.println(seqevent_numOUT+" "+master_ev[s6]+" "+icc[s6]+" "+icoh[s6]+" "+master_ev[s6]+" "+others_ev[s6]+" "+master_ev_ncss[s6]+" "+others_ev_ncss[s6]+" "+seq_prefix+""+seq_numOUT);
				     
				     				     
				     //sub_idtmp[idtmp]=master_ev_ncss[ss];

				     //idtmp++;
				     
				     //sub_idtmp[idtmp]=others_ev_ncss[ss];
				     //idtmp++;
				     
			
				     for(int s7=0;s7<uniq_num;s7++){
					 if(master_ev_ncss[s6].equals(ncss_uniq[s7])){
					     uniq_flag[s7]=1;						 
					 }
				     }

				     for(int s7=0;s7<uniq_num;s7++){
					 if(others_ev_ncss[s6].equals(ncss_uniq[s7])){
					     uniq_flag[s7]=1;						 
					 }
				     }

				     for(int s7=0;s7<uniq_num;s7++){
					 if(sub_uniq[s5].equals(ncss_uniq[s7])){
					     uniq_flag[s7]=1;						 
					 }
				     }



				     seqevent_numOUT++;
				     
				 }// work_flag2[s6]==1
				 
				 
			     }// if(work_flag[s6]==0){
			     
			     
			     
			 }//s6
		     }//sub_flag[s5]==0
		     
		 }//s5
		 
		 
		 


	     }// uniq_flag
	     
	 }
	 // add one. We start seq_numOUT -1
	 seq_numOUT++;
	 System.out.println("SEQNUM "+seq_numOUT);

    }
	 


    static public void show_workdata(){
	//System.out.println("# work_num = "+work_num);
	for(int s=0;s<work_num;s++){
	    System.out.println("# s = "+s+" master_ev_work = "+master_ev_work[s]+" others_ev_work = "+others_ev_work[s]+" cc_work = "+icc_work[s]+" coh_work = "+icoh_work[s]);
	    

	}
    }

}

